
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>The Varnish Reference Manual &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="VCL" href="vcl.html" />
    <link rel="prev" title="Troubleshooting Varnish" href="../users-guide/troubleshooting.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="vcl.html" title="VCL"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="../users-guide/troubleshooting.html" title="Troubleshooting Varnish"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">The Varnish Reference Manual</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="the-varnish-reference-manual">
<span id="reference-index"></span><h1>The Varnish Reference Manual<a class="headerlink" href="#the-varnish-reference-manual" title="Permalink to this headline">¶</a></h1>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="vcl.html">VCL</a><ul>
<li class="toctree-l2"><a class="reference internal" href="vcl.html#varnish-configuration-language">Varnish Configuration Language</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="states.html">Varnish Processing States</a><ul>
<li class="toctree-l2"><a class="reference internal" href="states.html#introduction">Introduction</a></li>
<li class="toctree-l2"><a class="reference internal" href="states.html#client-side">Client Side</a></li>
<li class="toctree-l2"><a class="reference internal" href="states.html#backend-side">Backend Side</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="varnish-cli.html">varnish-cli</a><ul>
<li class="toctree-l2"><a class="reference internal" href="varnish-cli.html#varnish-command-line-interface">Varnish Command Line Interface</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="varnishadm.html">varnishadm</a><ul>
<li class="toctree-l2"><a class="reference internal" href="varnishadm.html#control-a-running-varnish-instance">Control a running Varnish instance</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="varnishd.html">varnishd</a><ul>
<li class="toctree-l2"><a class="reference internal" href="varnishd.html#http-accelerator-daemon">HTTP accelerator daemon</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="varnishhist.html">varnishhist</a><ul>
<li class="toctree-l2"><a class="reference internal" href="varnishhist.html#varnish-request-histogram">Varnish request histogram</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="varnishlog.html">varnishlog</a><ul>
<li class="toctree-l2"><a class="reference internal" href="varnishlog.html#display-varnish-logs">Display Varnish logs</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="varnishncsa.html">varnishncsa</a><ul>
<li class="toctree-l2"><a class="reference internal" href="varnishncsa.html#display-varnish-logs-in-apache-ncsa-combined-log-format">Display Varnish logs in Apache / NCSA combined log format</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="varnishstat.html">varnishstat</a><ul>
<li class="toctree-l2"><a class="reference internal" href="varnishstat.html#varnish-cache-statistics">Varnish Cache statistics</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="varnishtest.html">varnishtest</a><ul>
<li class="toctree-l2"><a class="reference internal" href="varnishtest.html#test-program-for-varnish">Test program for Varnish</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="varnishtop.html">varnishtop</a><ul>
<li class="toctree-l2"><a class="reference internal" href="varnishtop.html#varnish-log-entry-ranking">Varnish log entry ranking</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="vsm.html">VSM: Shared Memory Logging and Statistics</a><ul>
<li class="toctree-l2"><a class="reference internal" href="vsm.html#shared-memory-trickery">Shared memory trickery</a></li>
<li class="toctree-l2"><a class="reference internal" href="vsm.html#the-varnish-way">The Varnish way:</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="vmod.html">VMOD - Varnish Modules</a><ul>
<li class="toctree-l2"><a class="reference internal" href="vmod.html#vmod-directory">VMOD Directory</a></li>
<li class="toctree-l2"><a class="reference internal" href="vmod.html#the-vmod-vcc-file">The vmod.vcc file</a></li>
<li class="toctree-l2"><a class="reference internal" href="vmod.html#vcl-and-c-data-types">VCL and C data types</a></li>
<li class="toctree-l2"><a class="reference internal" href="vmod.html#private-pointers">Private Pointers</a></li>
<li class="toctree-l2"><a class="reference internal" href="vmod.html#event-functions">Event functions</a></li>
<li class="toctree-l2"><a class="reference internal" href="vmod.html#when-to-lock-and-when-not-to-lock">When to lock, and when not to lock</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="vmod_generated.html">vmod_std</a><ul>
<li class="toctree-l2"><a class="reference internal" href="vmod_generated.html#varnish-standard-module">Varnish Standard Module</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="vmod_generated.html#vmod-directors">vmod_directors</a><ul>
<li class="toctree-l2"><a class="reference internal" href="vmod_generated.html#varnish-directors-module">Varnish Directors Module</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="vmod_generated.html#vmod-vtc">vmod_vtc</a><ul>
<li class="toctree-l2"><a class="reference internal" href="vmod_generated.html#utility-module-for-varnishtest">Utility module for varnishtest</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="vmod_generated.html#vmod-purge">vmod_purge</a><ul>
<li class="toctree-l2"><a class="reference internal" href="vmod_generated.html#varnish-purge-module">Varnish Purge Module</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="vmod_generated.html#vmod-blob">vmod_blob</a><ul>
<li class="toctree-l2"><a class="reference internal" href="vmod_generated.html#utilities-for-the-vcl-blob-type-encoding-and-decoding">Utilities for the VCL blob type, encoding and decoding</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="vmod_generated.html#vmod-unix">vmod_unix</a><ul>
<li class="toctree-l2"><a class="reference internal" href="vmod_generated.html#utilities-for-unix-domain-sockets">Utilities for Unix domain sockets</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="vmod_generated.html#vmod-proxy">vmod_proxy</a><ul>
<li class="toctree-l2"><a class="reference internal" href="vmod_generated.html#varnish-module-to-extract-tlv-attributes-from-proxyv2">Varnish Module to extract TLV attributes from PROXYv2</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="directors.html">Writing a Director</a><ul>
<li class="toctree-l2"><a class="reference internal" href="directors.html#backends-vs-directors">Backends vs Directors</a></li>
<li class="toctree-l2"><a class="reference internal" href="directors.html#cluster-directors">Cluster Directors</a></li>
<li class="toctree-l2"><a class="reference internal" href="directors.html#dynamic-backends">Dynamic Backends</a></li>
<li class="toctree-l2"><a class="reference internal" href="directors.html#health-probes">Health Probes</a></li>
<li class="toctree-l2"><a class="reference internal" href="directors.html#custom-backends">Custom Backends</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="varnish-counters.html">varnish-counters</a><ul>
<li class="toctree-l2"><a class="reference internal" href="varnish-counters.html#varnish-counter-field-definitions">Varnish counter field definitions</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="vsl.html">VSL</a><ul>
<li class="toctree-l2"><a class="reference internal" href="vsl.html#varnish-shared-memory-logging">Varnish Shared Memory Logging</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="vsl-query.html">vsl-query</a><ul>
<li class="toctree-l2"><a class="reference internal" href="vsl-query.html#varnish-vsl-query-expressions">Varnish VSL Query Expressions</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="vtc.html">VTC</a><ul>
<li class="toctree-l2"><a class="reference internal" href="vtc.html#varnish-test-case-syntax">Varnish Test Case Syntax</a></li>
</ul>
</li>
</ul>
</div>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="../users-guide/troubleshooting.html"
                        title="previous chapter">Troubleshooting Varnish</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="vcl.html"
                        title="next chapter">VCL</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/reference/index.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="vcl.html" title="VCL"
             >next</a> |</li>
        <li class="right" >
          <a href="../users-guide/troubleshooting.html" title="Troubleshooting Varnish"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">The Varnish Reference Manual</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>